import { QueryBus } from '@nestjs/cqrs';
import { Queue } from 'bull';
import { ICertificate, IClaimCommand, ITransferCommand, ISuccessResponse, BlockchainAction, IIssuedCertificate, IIssueCommandParams, IBatchClaimCommand, IBatchTransferCommand } from './types';
export declare class CertificateService<T = null> {
    private readonly queryBus;
    private readonly blockchainActionsQueue;
    constructor(queryBus: QueryBus, blockchainActionsQueue: Queue<BlockchainAction>);
    getAll(): Promise<ICertificate<T>[]>;
    getById(id: number): Promise<ICertificate<T> | null>;
    issue(params: IIssueCommandParams<T>): Promise<IIssuedCertificate<T>>;
    claim(command: IClaimCommand): Promise<ISuccessResponse>;
    transfer(command: ITransferCommand): Promise<ISuccessResponse>;
    batchIssue(originalCertificates: IIssueCommandParams<T>[]): Promise<number[]>;
    batchClaim(command: IBatchClaimCommand): Promise<ISuccessResponse>;
    batchTransfer(command: IBatchTransferCommand): Promise<ISuccessResponse>;
    private mapCertificate;
}
